Attribute VB_Name = "Module_QuickSort"
'###############################################################################################
Public Sub QuickSort(ByRef Arr, ByVal intSortBy As Integer, ByVal intLeft As Integer, ByVal intRight As Integer, Optional ByVal vDesc As Variant)
    Dim intNextLeft%
    Dim intNextRight%
    Dim strCompareWith
    Dim TempRow()
    Dim intCol%
    Dim Desc As Boolean
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    If Not IsMissing(vDesc) Then Desc = vDesc
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ReDim TempRow(UBound(Arr, 1), 0)
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    If intRight > intLeft Then
        strCompareWith = Arr(intSortBy, intRight)
        intNextLeft = intLeft - 1
        intNextRight = intRight
        '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        Do
            If Desc Then
                Do
                    intNextLeft = intNextLeft + 1
                Loop Until Arr(intSortBy, intNextLeft) <= strCompareWith
                Do
                    intNextRight = intNextRight - 1
                    If (intNextRight < intNextLeft) Or (intNextRight = 0) Then Exit Do
                Loop Until Arr(intSortBy, intNextRight) >= strCompareWith
            Else
                Do
                    intNextLeft = intNextLeft + 1
                Loop Until Arr(intSortBy, intNextLeft) >= strCompareWith
                Do
                    intNextRight = intNextRight - 1
                    If (intNextRight < intNextLeft) Or (intNextRight = 0) Then Exit Do
                Loop Until Arr(intSortBy, intNextRight) <= strCompareWith
            End If
            
            For intCol = 0 To UBound(Arr, 1)
                TempRow(intCol, 0) = Arr(intCol, intNextLeft)
                Arr(intCol, intNextLeft) = Arr(intCol, intNextRight)
                Arr(intCol, intNextRight) = TempRow(intCol, 0)
            Next intCol
            
        Loop Until intNextRight <= intNextLeft
        '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        For intCol = 0 To UBound(Arr, 1)
            Arr(intCol, intNextRight) = Arr(intCol, intNextLeft)
            Arr(intCol, intNextLeft) = Arr(intCol, intRight)
            Arr(intCol, intRight) = TempRow(intCol, 0)
        Next intCol
        '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        QuickSort Arr, intSortBy, intLeft, intNextRight, Desc
        QuickSort Arr, intSortBy, intNextLeft + 1, intRight, Desc
        '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    End If
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
End Sub
'###############################################################################################

