Attribute VB_Name = "Module_MetaStats_Common"
Option Explicit
'############################################################################################
Public Declare Sub Sleep Lib "kernel32" _
       (ByVal dwMilliseconds As Long)
'############################################################################################
'=== Common Low-Level Routines ==============================================================
'############################################################################################
Public Function RTV_sPath(ByVal sQryType As String, ByVal sNick As String) As String
'DownLoaded Files ReNaming Conventions
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    If (sQryType = "PGP-1") Then RTV_sPath = sNick & "_rlist.shtml"
    If (sQryType = "MIX-1") Then RTV_sPath = sNick & "_mlist.shtml"
    If (sQryType = "PGP-2") Then RTV_sPath = sNick & "_rlist2.shtml"
    If (sQryType = "MIX-2") Then RTV_sPath = sNick & "_mlist2.shtml"
    If (sQryType = "K-TY2") Then RTV_sPath = sNick & "_type2.lis"
    If (sQryType = "K-MIX") Then RTV_sPath = sNick & "_pubring.mix"
    If (sQryType = "K-RSA") Then RTV_sPath = sNick & "_rsakeys.asc"
    If (sQryType = "K-DSS") Then RTV_sPath = sNick & "_dsskeys.asc"
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
End Function
'############################################################################################
Public Function FSZ(ByVal sInput As String, iLen As Integer) As String
'Pads sInput with blanks or truncates, up to iLen
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    FSZ = Left(sInput & Space(iLen), iLen)
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
End Function
'############################################################################################
Public Function IsArrayEmpty(vArray As Variant) As Boolean
'Tests Arrays emptied or not yet initialized
On Error Resume Next
    Dim L As Long
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    L = UBound(vArray, 2)
    If (Err) Then
        MsgBox Err.Number & vbCrLf & Err.Description & vbCrLf & "Array not Initialized", vbCritical
        IsArrayEmpty = True
     End If
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
End Function
'############################################################################################
Public Sub SafeKill(sPath As String)
'Kills a File (Without Error_Message)
On Error Resume Next
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    If (Dir(sPath) <> "") Then Kill sPath
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
End Sub
'############################################################################################
Public Sub DSP_FeedBack(Form1 As Form, Optional sTotal As String, Optional sDetail As String, Optional dWait As Long)
'Handles the display of Status Labels: Total & Detail, + Sleep
'Logs App's Progress
    Dim fn As String
    Dim n As Integer
   '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    If (sTotal <> "") Then Form1.txt_FeedBackT = sTotal
    If (sDetail <> "") Then Form1.txt_FeedBackD = sDetail
    If (dWait <> 0) Then Sleep dWait
    Form1.Refresh
    DoEvents
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    fn = App.Path & "\" & App.EXEName & ".log"
    n = FreeFile
    Open fn For Append As #n
    Write #n, Now, Form1.txt_FeedBackT, Form1.txt_FeedBackD
    Close #n
    DoEvents
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
End Sub
'############################################################################################
Public Sub INZ_Log()
'Initializes (Clears) .log file
    Dim fn As String
    Dim n As Integer
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    fn = App.Path & "\" & App.EXEName & ".log"
    n = FreeFile
    Open fn For Output As #n
    Close #n
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
End Sub
'############################################################################################

